//========================================================================================
//	Release Version:	$ ODF 2 $
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.

//================================================================================
#include "DataCopy.hpp"

#ifndef PART_H
#include "Part.h"
#endif

#ifndef CONTENT_H
#include "Content.h"
#endif

#ifndef BINDING_K
#include "Binding.k"
#endif

#ifndef DEFINES_K
#include "Defines.k"
#endif

#ifndef FRAME_H
#include "Frame.h"
#endif

#ifndef SELECTION_H
#include "Selection.h"		// CDataCopySelection
#endif

// ----- Framework Layer -----
#ifndef FWPRESEN_H
#include "FWPresen.h"		// FW_CPresentation
#endif

#ifndef FWABOUT_H
#include "FWAbout.h"		//::FW_About()
#endif

//==============================================================================
#ifdef FW_BUILD_MAC
#pragma segment DataCopy
#endif

FW_DEFINE_AUTO(CDataCopyPart)

//==============================================================================
CDataCopyPart::CDataCopyPart(ODPart* odPart)
  :	FW_CPart(odPart, FW_gInstance, kPartInfoID),
	fPresentation(NULL),
	fPartContent(NULL)
{
	FW_END_CONSTRUCTOR
}

//--------------------------------------------------------------------------------
CDataCopyPart::~CDataCopyPart()
{
	FW_START_DESTRUCTOR
}

//--------------------------------------------------------------------------------
void 
CDataCopyPart::Initialize(Environment* ev, ODStorageUnit* storageUnit, 
							FW_Boolean fromStorage)	// Override
{
	FW_CPart::Initialize(ev, storageUnit, fromStorage);
	CDataCopySelection* selection = FW_NEW(CDataCopySelection, (ev, fPartContent));
	const ODType kMainPresentation = "Apple:Presentation:DataCopy";
	const FW_Boolean kDefaultPresentation = true;
	fPresentation = RegisterPresentation(ev, kMainPresentation, 
											kDefaultPresentation, selection);
}

//--------------------------------------------------------------------------------
FW_Handled 
CDataCopyPart::DoAbout(Environment* ev)	// Override
{
	::FW_About(ev, this, kAbout);
	
	return FW_kHandled;
}

//--------------------------------------------------------------------------------
FW_CFrame* 
CDataCopyPart::NewFrame(Environment* ev, ODFrame* odFrame,
						FW_CPresentation* presentation, FW_Boolean fromStorage)	// Override
{
	FW_UNUSED(fromStorage);
	return FW_NEW(CDataCopyFrame, (ev, odFrame, presentation, fPartContent));
}

//------------------------------------------------------------------------------
FW_CContent* 
CDataCopyPart::NewPartContent(Environment* ev)
{
	fPartContent = FW_NEW(CDataCopyContent, (ev, this));
	return fPartContent;
}

//------------------------------------------------------------------------------
void 
CDataCopyPart::MyInvalidatePresentation(Environment* ev, FW_CRect& rect)
{
	fPresentation->Invalidate(ev, rect);
}

//------------------------------------------------------------------------------
void 
CDataCopyPart::MyInvalidatePresentation(Environment* ev)
{
	fPresentation->Invalidate(ev);
}
