//	Release Version:	$ ODF 2 $
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.

//========================================================================
#ifndef SELECTION_H
#include "Selection.h"	// CDataCopySelection
#endif

#ifndef CONTENT_H
#include "Content.h"	// CDataCopyContent
#endif

// ----- Framework Layer -----
#ifndef FWPRESEN_H
#include "FWPresen.h"
#endif

//========================================================================
#ifdef FW_BUILD_MAC
#pragma segment DataCopy
#endif

FW_DEFINE_AUTO(CDataCopySelection)
//========================================================================
CDataCopySelection::CDataCopySelection(Environment* ev, CDataCopyContent* content)
  :	FW_CSelection(ev, false, false),
	fDataCopyContent(content)
{
	FW_END_CONSTRUCTOR
}

//-------------------------------------------------------------------------
CDataCopySelection::~CDataCopySelection()
{	
	FW_START_DESTRUCTOR
}

//-------------------------------------------------------------------------
void 
CDataCopySelection::CloseSelection(Environment*)
{
}

//-------------------------------------------------------------------------
void 
CDataCopySelection::ClearSelection(Environment* ev)
{
	fDataCopyContent->MyRemoveAllPizzas();
	this->GetPresentation(ev)->Invalidate(ev);
}

//-------------------------------------------------------------------------
void 
CDataCopySelection::SelectAll(Environment*)
{
}

//-------------------------------------------------------------------------
FW_Boolean 
CDataCopySelection::IsEmpty(Environment* ev) const
{
	FW_UNUSED(ev);
	unsigned long count = fDataCopyContent->MyGetPizzaList()->Count();
	return (count == 0);			
}

//-------------------------------------------------------------------------
FW_CContent* 
CDataCopySelection::GetSelectedContent(Environment* ev)
{
	FW_UNUSED(ev);
	return fDataCopyContent;
}
